From a64ad2e73869ce6d1369a584e634f6c9e4af6b7c Mon Sep 17 00:00:00 2001
From: ChangAo Chen <cca5507@qq.com>
Date: Mon, 7 Jul 2025 13:05:34 +0800
Subject: [PATCH v1] Small optimization with expanding dynamic hash table

---
 src/backend/utils/hash/dynahash.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/src/backend/utils/hash/dynahash.c b/src/backend/utils/hash/dynahash.c
index 1ad155d446e..32fbae71995 100644
--- a/src/backend/utils/hash/dynahash.c
+++ b/src/backend/utils/hash/dynahash.c
@@ -1626,7 +1626,7 @@ expand_table(HTAB *hashp)
 		 currElement = nextElement)
 	{
 		nextElement = currElement->link;
-		if ((long) calc_bucket(hctl, currElement->hashvalue) == old_bucket)
+		if (!(currElement->hashvalue & (hctl->low_mask + 1)))
 		{
 			*oldlink = currElement;
 			oldlink = &currElement->link;
-- 
2.34.1

